import type { VotingSystem } from '../types';
import { type Methods, methods } from '../methods';
declare type MethodsContaining<StaticProp extends 'isRandom' | 'needsBallot' | 'needsMatrix', Method> = Method extends Methods ? Method[StaticProp] extends true ? Method : never : never;
declare type SystemsBeing<MethodType extends Methods, System> = System extends VotingSystem ? typeof methods[System] extends MethodType ? System : never : never;
export declare type RandomMethods = MethodsContaining<'isRandom', Methods>;
export declare type BallotMethods = MethodsContaining<'needsBallot', Methods>;
export declare type MatrixMethods = MethodsContaining<'needsMatrix', Methods>;
export declare type RandomSystem = SystemsBeing<RandomMethods, VotingSystem>;
export declare type BallotSystem = SystemsBeing<BallotMethods, VotingSystem>;
export declare type MatrixSystem = SystemsBeing<MatrixMethods, VotingSystem>;
export declare const isRandomMethod: (Method: Methods) => Method is RandomMethods;
export declare const isBallotMethod: (Method: Methods) => Method is BallotMethods;
export declare const isMatrixMethod: (Method: Methods) => Method is MatrixMethods;
export declare const isRandomSystem: (system: VotingSystem) => system is RandomSystem;
export declare const isBallotSystem: (system: VotingSystem) => system is BallotSystem;
export declare const isMatrixSystem: (system: VotingSystem) => system is MatrixSystem;
export {};
